unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.VarCmplx, system.Math,
  Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Button2: TButton;
    LabeledEdit1: TLabeledEdit;
    Button3: TButton;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
var
  NLabeledEdit: array of TLabeledEdit;
  Nd :  integer;

  one   : double = 1;
  zero  : double = 0;

type
  TCdouble = record
    r : double;
    i : double;
  end;

function MCdouble(r, i:double): TCdouble;
begin
  result.r := r;
  result.i := i;
end;

// a + b
function cadd(a, b: TCdouble): TCdouble;
begin
  result.r := a.r + b.r;
  result.i := a.i + b.i;
end;

// a - b
function csub(a, b: TCdouble): TCdouble;
begin
  result.r := a.r - b.r;
  result.i := a.i - b.i;
end;

// a * b
function cmul(a, b: TCdouble): TCdouble;
begin
  result.r := a.r * b.r - a.i * b.i;
  result.i := a.r * b.i + a.i * b.r;
end;

// a / b
function cdiv(a, b: TCdouble): TCdouble;
var
  bb: double;
begin
  result.r := 0;
  result.i := 0;
  bb := b.r * b.r + b.i * b.i;
  if bb <> 0 then begin
    result.r := (a.r * b.r + a.i * b.i) / bb;
    result.i := (a.i * b.r - a.r * b.i) / bb;
  end;
end;

function polynomial(p: array of double; x: double; n: integer): double;
var
  i : integer;
  r : double;
begin
	r := p[n-1];
	for i := n - 2 downto 0 do r := r * x + p[i];
	result := r;
end;

// Durand Kerner Aberth algorithm
function dka(a: array of double; var c: array of TCdouble; n: integer): boolean;
var
  r, r0, t : double;
  e : double;
  f, w, p, ca: TCdouble;
  norm: double;
  i, j, L: integer;
  ba : array of double;
  b : array of double;
  db: array of double;
  zc : double;
begin
  setlength(ba, n + 1);
  setlength(b, n + 1);
  setlength(db, n);
                                              // a̐ݒ
  for i := 0 to n do ba[i] := a[i];
  zc := -ba[n-1] / n;

  for i := 1 to n do
    for j := n downto i do
      ba[j-1] := ba[j-1] + ba[j] * zc;

	for i := 0 to n - 1 do b[i] := -abs(ba[i]);
  b[n] := ba[n];

  r := 0;                                     // l
  for i := 0 to n - 1 do begin
    r0 := power(n * abs(b[i]), 1/(n-i));
    if r < r0 then r := r0;
  end;
  Form1.Memo1.Lines.Add('R = ' + floatTostr(R));

	for i := 1 to n do db[i-1] := b[i] * i;     // db(r) = b'(r)

  L := 0;
  repeat                                      // Newton's method
		r0 := polynomial(b, r, n + 1) / polynomial(db, r, n);
		r := r - r0;
    inc(L);
	until (abs(r0) < 1E-10) or (L > 100);

  Form1.Memo1.Lines.Add('calculate radius Loop = ' + intTostr(L));
  Form1.Memo1.Lines.Add('aR No2 = ' + floatTostr(r));

  for i := 1 to n  do begin                   // ar̉~ɓԊuɔzu
    t := 2 * PI / n * (i - 3 / 4.0);
    c[i-1].r := r * cos(t) - a[n-1] / n;      // A[oX̏l
    c[i-1].i := r * sin(t);
  end;

  L := 0;
  repeat                                      // @
    e := 0;                                   // ʒl
    for i := 0 to n - 1 do begin
      f := MCdouble(one, zero);               // q@f(zi)
      for j := n - 1 downto 0 do begin        // z[i[@
        w := cmul(f, c[i]);                   // z
        f.r := w.r + a[j];                    // f=z+a[j]
        f.i := w.i;
      end;
      p := MCdouble(one, zero);
      for j := 0 to  n - 1 do begin
        if j <> i then begin
          p := cmul(p, csub(c[i], c[j]));     // p*(zi-zj)
        end;
      end;

      t := p.r * p.r + p.i * p.i;             // p0lmF
      if t = 0 then begin
        application.MessageBox('ꂪ[łZł܂B', '', 0);
        result := false;
        exit;
      end;
      ca := cdiv(f, p);
      norm := sqrt(ca.r * ca.r + ca.i * ca.i);
      if e < norm then e := norm;             // ől
      c[i] := csub(c[i], ca);                 // Lڂ̋ߎ
    end;
  inc(L);
  until (e < 1E-10) or (L > 500);

  result := true;
  Form1.Memo1.Lines.Add('Loop = ' + intTostr(L))
end;

// nx^n + n-1x^n-1 + n-2x^n-2 + c +1x + 0 ̌vZ
function poly8(a: array of double; c : TCdouble; n: integer): TCdouble;
var
  i     : integer;
  x     : array of Variant;
  fxn   : array of Variant;
begin
  setlength(x, n);
  setlength(fxn, n + 1);
  for i := 0 to n -1 do x[i] := varascomplex(x[i]);      // VarComplexCreate̓[[N
  for i := 0 to n  do fxn[i] := varascomplex(fxn[i]);    // ܂B

  x[0].real := c.r;
  x[0].imaginary := c.i;
  for i := 1 to n - 1 do x[i] := x[0] * x[i - 1];
  for i := n  downto 1 do begin
    fxn[i] .real := a[i];
    fxn[i] .imaginary := zero;
    fxn[i] := fxn[i] * x[i - 1];
  end;
  fxn[0].real := a[0];
  fxn[0].imaginary := zero;

  x[0] := fxn[0];
  for i := 1 to  n do x[0] := x[0] + fxn[i];
  result.r := x[0].real;
  result.i := x[0].imaginary;
end;

// @ƌʕ\
procedure TForm1.Button1Click(Sender: TObject);
var
  a : array of double;
  c : array of TCdouble;
  s : TCdouble;
	i, n, j, ch: integer;
  fd   : double;
  ad   : array of double;
  li   : int64;
  scou : string;
begin
  n := 0;
  // [łȂl̏ꏊ̌
  for i := Nd downto 0 do begin
    val(NLabeledEdit[i].Text, fd, ch);
    if ch <> 0 then begin
      scou := '' + intTostr(i - 1) + 'lł͂܂B';
      application.MessageBox(pchar(scou),'',0);
      exit;
    end;
    if (fd <> 0) and (n = 0) then  n := i;  // [łȂʒu 
  end;
  if n < 1 then begin
    application.MessageBox('1̒l[łAꎟȉ͂܂B','',0);
    exit;
  end;
  button1.Enabled := false;
  // Ŕz̊m
  setlength(a, n + 1);
  setlength(c, n);
  // Sf[^[̔z̊m
  setlength(ad, Nd + 1);

  // f[^[͏
  for i := n downto 0 do begin
    val(NLabeledEdit[i].Text, a[i], ch);
  end;
  // 擪̒lPɐݒ
  for i := n - 1 downto 0 do begin
    a[i] := a[i] / a[n];
  end;
  a[n] := 1;

  memo1.Clear;
  memo1.Lines.Add(' = ' + intTostr(n));
  // dka@@vZ
  dka(a, c, n);
  // \
  for i := 0 to n-1 do begin
    fd := c[i].r;
    if not checkbox1.Checked then
      if abs(fd) < 1E5 then begin
        li := round(fd * 1E8);                // _8ȉۂ
        fd := li / 1E8;
      end;
    scou := 'x' + inttostr(i + 1) + '= ' + floatTostr(fd);
    ch := length(scou);
    ch := 30 - ch;
    for j := 0 to ch do scou := scou + ' ';
    fd := c[i].i;
    if not checkbox1.Checked then
      if abs(fd) < 1E5 then begin
        li := round(fd * 1E8);                // _8ȉۂ
        fd := li / 1E8;
      end;
    memo1.Lines.Add(scou + floatTostr(fd) + ' i');
  end;
  // Z
  for i := 0 to Nd do begin                   // ͒l̃Rs[
    ad[i] := 0;
    if i <= n then ad[i] := a[i];
  end;
  memo1.Lines.Add('Z@Xn vZ');
  for j := 0 to n-1 do begin
    s := poly8(ad, c[j], n);                   // nvZ
    fd := s.r;
    if not checkbox1.Checked then
      if abs(fd) < 1E5 then begin
        li := round(fd * 1E7);                // _7ȉۂ
        fd := li / 1E7;
      end;
    scou := 'xans' + inttostr(j + 1) + '= ' + floatTostr(fd);
    ch := length(scou);
    ch := 30 - ch;
    fd := s.i;
    if not checkbox1.Checked then
      if abs(fd) < 1E5 then begin
        li := round(fd * 1E7);                // _7ȉۂ
        fd := li / 1E7;
      end;
    for i := 0 to ch do scou := scou + ' ';
    memo1.Lines.Add(scou + floatTostr(fd) + ' i');
  end;
  button1.Enabled := true;
end;

// Zbg
procedure TForm1.Button2Click(Sender: TObject);
var
  i: integer;
  testdata : double;
  Total    : double;
begin
  if Nd <> 0 then begin
    for i := 0 to Nd do NLabeledEdit[i].Free;
    Nd := 0;
  end;

  val(LabeledEdit1.Text, Nd, i);
  if i <> 0 then begin
    application.MessageBox('ԈĂ܂B','',0);
    Nd := 0;
    exit;
  end;

  if Nd < 1 then begin
    application.MessageBox('Ȃ܂B','',0);
    Nd := 0;
    exit;
  end;
  if ND > 20 then begin
    application.MessageBox('܂B','',0);
    Nd := 0;
    exit;
  end;
  height := 478 + (Nd - 8) * 40 + 80;
  panel1.Height := 380 + (Nd - 8) * 40;
  LabeledEdit1.top := clientheight - 33;
  button1.top := clientheight - 35;
  button2.top := clientheight - 35;
  button3.top := clientheight - 35;
  memo1.Height := 356 + (Nd - 8) * 40 + 80;
  checkbox1.top := clientheight - 35;
//  top := (screen.Height - height) div 2;
//  left := (screen.Width - width) div 2;
  setlength(NLabeledEdit, Nd +1);
  for i:=0 to Nd do NLabeledEdit[i] := nil;
  for i:=0 to Nd do begin
    NLabeledEdit[i] := TLabeledEdit.Create(form1.Panel1);
    NLabeledEdit[i].Parent := form1.Panel1;
    NLabeledEdit[i].Left:= 10;
    NLabeledEdit[i].top := form1.Panel1.Height - 40 * (i) - 35;
    NLabeledEdit[i].Width := 120;
    NLabeledEdit[i].Alignment := tacenter;
    NLabeledEdit[i].EditLabel.Font.Size := 11;
    NLabeledEdit[i].EditLabel.Caption := '' + intTostr(i);
    NLabeledEdit[i].Font.Size := 9;
    NLabeledEdit[i].Text := floatTostr(power(10, i));
    NLabeledEdit[i].Height := 22;
  end;
  total := 0;
  for i:=1 to Nd do begin
    testdata := 1;
    total := total - testdata;
    NLabeledEdit[i].Text := floatTostr(testdata);
  end;
  NLabeledEdit[0].Text := floatTostr(total);
  button1.Enabled := true;
end;

// eXgf[^[Zbg
procedure TForm1.Button3Click(Sender: TObject);
begin
  LabeledEdit1.Text := '8';
  button2Click(nil);
  NLabeledEdit[0].Text := '40320';
  NLabeledEdit[1].Text := '-109584';
  NLabeledEdit[2].Text := '118124';
  NLabeledEdit[3].Text := '-67284';
  NLabeledEdit[4].Text := '22449';
  NLabeledEdit[5].Text := '-4536';
  NLabeledEdit[6].Text := '546';
  NLabeledEdit[7].Text := '-36';
  NLabeledEdit[8].Text := '1';
end;

// ʐݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  width := 718;
  height := 478 + 80;
  top := (screen.Height - height) div 2;
  left := (screen.Width - width) div 2;
  button1.Enabled := False;
  panel1.Width := 140;
  panel1.Height := 380;
  panel1.top := 29;
  panel1.Left := 543;
  memo1.Left := 8;
  memo1.Height := 356 + 80;
  memo1.Width := 520;
  memo1.Top := 29;
  LabeledEdit1.Top := clientheight - 33;
  button1.top := clientheight - 35;
  button2.top := clientheight - 35;
  button3.top := clientheight - 35;
  checkbox1.top := clientheight - 35;
  Nd := 0;
end;

end.
